var loggedInUsers = {};
var userPwd = {};

function index(req, res) {
    if (req.session.username) {
        res.redirect("/users");
    } else {
	res.render('index', { title: 'COMP 2406 Session Demo', 
			      error: req.query.error });
    }
}

function users(req, res) {
    if (req.session.username) {
	res.render("account.jade", {username:req.session.username,
				    title:"Account",
				    loggedInUsers: loggedInUsers});
    } else {
	res.redirect("/?error=Error: Not Logged In");
    }
};

function login(req, res) {
    var username = req.body.username;
    var password = req.body.password;

    if (!username) {
	res.redirect("/?error=Please enter a username");	
    }

    if (req.body.whichbutton === "register") {
	// register button pressed
	if (userPwd[username]) {
	    res.redirect("/?error=Error: User has already registered.")
	} else {
	    userPwd[username] = password;
	    res.redirect("/?error=User now registered")
	}
    } else {
	// assume login button pressed
	// (if paranoid check for login in whichbutton)
	if (userPwd[username]) {  // is the user registered?
	    if (userPwd[username] === password) {
		req.session.username = username;

		if (loggedInUsers[username]) {
		    loggedInUsers[username]++;
		} else {
		    loggedInUsers[username] = 1;
		}
		
		res.redirect("/users")
	    } else {
		// incorrect password entered
		res.redirect("/?error=Error: Incorrect username/password");
	    }
	} else {
	    // incorrect username entered
	    res.redirect("/?error=Error: Incorrect username/password");
	}
    }
}

function logout(req, res) {
    var username = req.session.username;

    if (username && loggedInUsers[username]) {
	loggedInUsers[username]--;
	if (loggedInUsers[username] <= 0) {
	    delete loggedInUsers[username];
	}
    }
    req.session.destroy(function(err){
        if(err){
            console.log("Error: %s", err);
        }
    });
    res.redirect("/");
}

exports.index = index;
exports.users = users;
exports.login = login;
exports.logout = logout;
